#Compile Exe

#Debug Error On
#Debug Display On

%TRUE  = 1
%FALSE = 0

#Link "xmlExcel.sll"

Function PBMain() As Long      


    ' Create some interface variables to handle our Workbook,
    ' Worksheets, and individual Cells.
    Local wb    As iExcelWorkBook
    Local ws    As iExcelWorkSheet
    Local iCell As iExcelCell
    
    ' Create a Workbook class
    Let wb = Class "clsExcelWorkBook"
    
    ' Assign some Workbook info. This stuff is optional.
    wb.filename = "xmlExcelTestJPL.xml"
    wb.author   = "Jean-Pierre Leroy"
    wb.company  = "My company"
    
    ' Add a worksheet and call it "Sheet1"
    Let ws = wb.AddWorkSheet("Sheet1")
    
    ' adjust column width
    ws.SetColumnWidth  1,  30  ' Number
    ws.SetColumnWidth  2, 380  ' Project        
    ws.SetColumnWidth  3, 160  ' Scope
    ws.SetColumnWidth  4,  71  ' Approved
    ws.SetColumnWidth  5,  48  ' Priority
    ws.SetColumnWidth  6,  59  ' Status
    ws.SetColumnWidth  7, 150  ' User name          
    ws.SetColumnWidth  8, 150  ' Managed by             
    ws.SetColumnWidth  9, 150  ' Sponsor
    ws.SetColumnWidth 10, 400  ' Description and goals
    ws.SetColumnWidth 11, 400  ' Expected improvements
    ws.SetColumnWidth 12, 400  ' Follow-up and comments
    ws.SetColumnWidth 13,  57  ' Start date 
    ws.SetColumnWidth 14,  57  ' Due date    
    ws.SetColumnWidth 15,  86  ' Man-days TOTAL
    ws.SetColumnWidth 16,  33  ' DONE
    ws.SetColumnWidth 17,  61  ' REMAINING
    ws.SetColumnWidth 18,  85  ' Achievement (%)
    ws.SetColumnWidth 19,  90  ' External costs (KE)        
    ws.SetColumnWidth 20,  40  ' Memos
    ws.SetColumnWidth 21, 150  ' Created by
    ws.SetColumnWidth 22,  97  ' Created date
    ws.SetColumnWidth 23, 150  ' Updated by
    ws.SetColumnWidth 24,  97  ' Updated date                 
       
    ' Set some print parameters for this worksheet.
    ws.PageCenterVertical   = 1      ' default 0
    ws.PageCenterHorizontal = 1      ' default 0
    ws.PageLandscape        = %TRUE    

    '------------------------------
    ' write the Header (first line)
   '------------------------------
    Local lCellColor As String
    lCellColor = "#E6D8AD" ' marron 
    Local lRow As LONG
    Incr lRow
    iCell = ws.AddCell(lRow,  1, "Num")                    : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.AlignRight = %TRUE                  
    iCell = ws.AddCell(lRow,  2, "Project")                : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow,  3, "Scope")                  : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow,  4, "Approved")               : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow,  5, "Priority")               : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor 
    iCell = ws.AddCell(lRow,  6, "Status")                 : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor    
    iCell = ws.AddCell(lRow,  7, "User name")              : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow,  8, "Managed by")             : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow,  9, "Sponsor")                : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 10, "Description and goals")  : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.WrapText  = %TRUE 
    iCell = ws.AddCell(lRow, 11, "Expected improvements")  : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.WrapText  = %TRUE 
    iCell = ws.AddCell(lRow, 12, "Follow-up and comments") : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.WrapText  = %TRUE     
    iCell = ws.AddCell(lRow, 13, "Start date")             : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 14, "Due date")               : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 15, "Man-days TOTAL")         : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.AlignRight = %TRUE 
    iCell = ws.AddCell(lRow, 16, "DONE")                   : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.AlignRight = %TRUE 
    iCell = ws.AddCell(lRow, 17, "REMAINING")              : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor : iCell.AlignRight = %TRUE 
    iCell = ws.AddCell(lRow, 18, "Achievement (%)")        : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 19, "External costs (KE)")    : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 20, "Memos")                  : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor              
    iCell = ws.AddCell(lRow, 21, "Created by")             : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 22, "Created date")           : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 23, "Updated by")             : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor
    iCell = ws.AddCell(lRow, 24, "Updated date")           : iCell.FontBold = %TRUE : iCell.CellColor = lCellColor         
 
    ' Write our workbook to disk
    wb.WriteXML
    
    ' Clean up after ourselves
    Set ws = Nothing
    Set wb = Nothing
    
    ? "Done."

End Function
